/**
 * \file: main.c
 *
 * \brief AVR135: PWMޭè ّւϕߊlgp
 *
 * 쌠 (C) 2016 Atmel Corporation. s
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 */
/*
 * xFAQ: <a href="http://www.atmel.com/design-support/">Atmelx</a>q˂ĂB
 */
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include "icp.h"
#include "device.h"

static volatile unsigned char hb_count = 0;		/* 邽߂̌v[0`4] */

/**
 * TIMER0_OVF()
 *
 * /0ꊄ荞ݏٰ
 * (/2PWMޭè قXV܂B)
 */
ISR(TIMER0_OVF_vect)
{
	if (++hb_count >= 32)	// T0.25so߂ŁA(悤ɂ邽)
	{
		hb_count = 0;		// v평
		REG_DUTYCYCLE += 1;			// T/C2PWMޭè ّ/ۂ(0`255)
	}
}

/**
 * hb_init()
 *
 * (XV)v평
 *
 * PWMɑ΂ޭè قXV܂B8MHzۯgp
 * āA1024Ou(8ޯ)v͖32Hzň܂B荞ݏٰݓ̌v
 * (0`31)ޭè قT1Hzŕς悤32v邱ƂɂĂx
 * ܂B͒PLEDŉ̂ɏ[ɒxƂKvȂłB
 */
void hb_init(void)
{
	REG_ASYNC_STATUS = 0;					// 񓯊֎~/ݒ(AS0/AS2=0)
	while (REG_ASYNC_STATUS) ;				// ASSRXVҋ@
	REG_TC0_CONTROL = REG_TC0_CLKSEL;		// 1024OuŎn(Rs)
	REG_TC0_INTMASK = MSK_TC0_INTENABLE;	// /0ꊄ荞݋
}

/**
 * pwm_init()
 *
 * ړIpPWM(/2)n
 * ICP1荞ݏٰ(icp.c)ɂĕ񔽓]PWM쓮܂B
 * ڑɂĂ͉pLq܂device.hQƂĂB
 */
void pwm_init(void)
{
	PORT_PWM_OUTPUT |= MSK_PWM_OUTPUT;		// OC2(A)ݏo͐ݒ
	REG_DUTYCYCLE = 0;						// rڼ޽(0%)
	REG_TC2_CONTROLA = MSK_TC2_CONTROLA;	// TC2ڼ޽A (PWM,񔽓]PWM)
	REG_TC2_CONTROLB = MSK_TC2_CONTROLB;	// TC2ڼ޽A (64Ŏn)

}

/**
 * main()
 *
 * ۸
 * 
 */
int main(void)
{
	icp_sample_t sample;

	hb_init();						// XVv평(TC0:main.c)
	icp_init();						// ߊl͌v평(TC1:icp.c)
	pwm_init();						// PWM(TC2:main.c)

	/* LEDޯޗp߰ď */
	LED_DEBUG_PORT = 0xFF;			// LED\p߰CSޯLo͐ݒ
	LED_DEBUG_DDR = 0xFF;			// LED\p߰CSޯďo͐ݒ

	/* x~ݒƋx~̏N */
	sei();							// S̊荞݋
	sleep_enable();					// ًx~ֈڍs

	for (;;)	// JԂ
	{
		sample = icp_rx();			// ŏI̎()l擾
		LED_DEBUG_PORT = ~sample;	// ̎l(_])LED\

		sleep_cpu();				// ًx~ֈڍs
		// ̊荞݂܂ŋx~BPWM2xƔ/XVvɊւ
		// b(T)1Nオ܂B͕KvƂpxłA
		// ̎ɊւĊԈႢȂ\łB
	}
	return(0);						// (B꓾Ȃs)
}
